unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, TeeGDIPlus, StdCtrls,
  TeEngine, TeeProcs, Chart, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Panel2: TPanel;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    procedure Chart1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
    PTarray : array of TPoint;
    Drawing : boolean;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses TeeConst, TeCanvas;

var Chart1: TChart;

procedure TForm1.Chart1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if (ssCtrl in Shift) then
     begin
       // Check if we are starting to draw a new polygon
       if Length(PTarray) <= 0  then
         begin
           // Initialize the array to hold the polygon vertex list.
           // Allocate an extra element to hold the curent mouse position
           // and use it for the last/next vertex.
           SetLength(PTarray, 2);
           PTarray[0].X := X;
           PTarray[0].Y := Y;
           Drawing := True;
         end

       else if Length(PTarray) > 1 then
         begin
           // Clear the old line we were stretching to the last vertex
           Chart1.Canvas.Pen.Color := clBlack;
           Chart1.Canvas.Brush.Style := bsSolid;
           Chart1.Canvas.Pen.Mode := pmXor;
           Chart1.Canvas.Pen.Width := 1;
           Chart1.Canvas.Polyline(PTarray);

           // Increase the array to hold the new vertex.
           SetLength(PTarray, Length(PTarray)+1);
         end;

       // Save the new vertex
       PTarray[High(PTarray)].X := X;
       PTarray[High(PTarray)].Y := Y;

       // Draw a line from the previous vertex to this new one
       Chart1.Canvas.Pen.Color := clBlack;
       Chart1.Canvas.Brush.Style := bsSolid;
       Chart1.Canvas.Pen.Mode := pmXor;
       Chart1.Canvas.Pen.Width := 1;
       Chart1.Canvas.Polyline(PTarray);
     end
   else
     begin
       // Close the polygon;
       Drawing := False;
       SetLength(PTarray, Length(PTarray)+1);
       PTarray[High(PTarray)] := PTarray[0];
       Chart1.Canvas.Polyline(PTarray);
       SetLength(PTarray, 0);
     end;
end;

procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  // Check if we are drawing the polygon
  if Drawing then
    begin
      Chart1.Canvas.Pen.Color := clBlack;
      Chart1.Canvas.Brush.Style := bsSolid;
      Chart1.Canvas.Pen.Mode := pmXor;

      // Remove the old line
      Chart1.Canvas.Pen.Width := 1;
      Chart1.Canvas.Polyline(PTarray);

      // Save new point
      PTarray[High(PTarray)].X := X;
      PTarray[High(PTarray)].Y := Y;

      // Draw the new line
      Chart1.Canvas.Pen.Width := 1;
      Chart1.Canvas.Polyline(PTarray);
    end
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Chart1:=TChart.Create(Self);
  Chart1.Parent:=Self;
  Chart1.Align:=alClient;

  Label1.Caption:=TeeMsg_Version;

  Chart1.OnMouseDown:=Chart1MouseDown;
  Chart1.OnMouseMove:=Chart1MouseMove;

  if Chart1.Canvas is TGDIPlusCanvas then
    RadioGroup1.ItemIndex:=1
  else if Chart1.Canvas is TTeeCanvas3D then
    RadioGroup1.ItemIndex:=0;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
    0: Chart1.Canvas:=TTeeCanvas3D.Create;
    1: Chart1.Canvas:=TGDIPlusCanvas.Create;
  end;
end;

end.
